@echo off
setlocal enabledelayedexpansion

pushd %~dp0
set REL_PATH=..\
pushd %REL_PATH%
set ABS_PATH=%CD%
popd

set OPENRADIOSS_PATH=%ABS_PATH%
set RAD_CFG_PATH=%OPENRADIOSS_PATH%\hm_cfg_files
set RAD_H3D_PATH=%OPENRADIOSS_PATH%\extlib\h3d\lib\win64
set KMP_STACKSIZE=400m
set PATH=%OPENRADIOSS_PATH%\extlib\hm_reader\win64;%PATH% 
set PATH=%OPENRADIOSS_PATH%\extlib\intelOneAPI_runtime\win64;%PATH%

set file=%1
set nt=%2
set np=%3
set sp=%4
set vtk=%5
set csv=%6
set starter=%7

for %%A in (%file%) do (
  set runningDirectory=%%~dpA
  set jobName=%%~nA
  set extension=%%~xA
)

if not "%extension%"==".rad" (
  if "%extension%"==".k" (
    set jobname=%jobname%
  ) else if "%extension%"==".key" (
    set jobname=%jobname%
  ) else (
    echo Check input file.
    echo Error termination.
    exit /b
  )
)

if "%extension%"==".rad" (
  set jobSuffix=%jobName:~-4%
  set jobName=%jobName:~0,-5%
  echo %jobSuffix% | findstr [0-9][0-9][0-9][0-9]>NUL
  if not %ERRORLEVEL%==0 (
    echo Check input file.
    echo Error termination.
    exit /b
  )
)

if "%extension%"==".rad" (
  set /a runID=%jobSuffix%
) else (
  set runID=0
)

dir /b | findstr "path_to_mpi_vars.txt"$>NUL
  if %ERRORLEVEL%==0 (
  set /p MPI_PATH=<path_to_mpi_vars.txt 
) else (
  set MPI_PATH=
)

set starterexec=\exec\starter_win64.exe
set engineexec=\exec\engine_win64.exe
set enginempiexec=\exec\engine_win64_impi.exe

if %sp%==sp (
  set starterexec=\exec\starter_win64_sp.exe
  set engineexec=\exec\engine_win64_sp.exe
  set enginempiexec=\exec\engine_win64_impi_sp.exe
)

pushd %runningDirectory%
if %runID%==0 (
  for /f "usebackq" %%f in (`dir /b ^| findstr %jobName%.h3d`) do del %%f
  for /f "usebackq" %%f in (`dir /b ^| findstr %jobName%_[0-9][0-9][0-9][0-9].out`) do del %%f
  for /f "usebackq" %%f in (`dir /b ^| findstr %jobName%_[0-9][0-9][0-9][0-9].ctl`) do del %%f
  for /f "usebackq" %%f in (`dir /b ^| findstr %jobName%_[0-9][0-9][0-9][0-9]_[0-9][0-9][0-9][0-9].rst`) do del %%f
  for /f "usebackq" %%f in (`dir /b ^| findstr %jobName%A[0-9][0-9][0-9]$`) do del %%f
  for /f "usebackq" %%f in (`dir /b ^| findstr %jobName%A[0-9][0-9][0-9].vtk`) do del %%f
  for /f "usebackq" %%f in (`dir /b ^| findstr %jobName%T[0-9][0-9]$`) do del %%f
  for /f "usebackq" %%f in (`dir /b ^| findstr %jobName%T[0-9][0-9].csv`) do del %%f

if "%extension%"==".rad" ( 
  if "%starter%"=="no" (
    echo %jobName%_!jobSuffix!>.\running_st_%jobName%
    set jobFileFullPath=%runningDirectory%%jobName%_!jobSuffix!%extension%
  ) else (
    echo %jobName%_!jobSuffix!>.\stopping_st_%jobName%
    set jobFileFullPath=%runningDirectory%%jobName%_!jobSuffix!%extension%
  )
) else (
  if "%starter%"=="no" (
    echo %jobName%!jobSuffix!>.\running_st_%jobName%
    set jobFileFullPath=%runningDirectory%%jobName%!jobSuffix!%extension%
  ) else (
    echo %jobName%!jobSuffix!>.\stopping_st_%jobName%
    set jobFileFullPath=%runningDirectory%%jobName%!jobSuffix!%extension%
  )
)
  %OPENRADIOSS_PATH%!starterexec! -i !jobFileFullPath! -nt %nt% -np %np%
    dir /b | findstr running_st_%jobName%>NUL
    if !ERRORLEVEL!==0 (
      del running_st_%jobName%
    )
if "%extension%"==".rad" (
    dir /b | findstr %jobName%_!jobSuffix!_0001.rst>NUL
    if not !ERRORLEVEL!==0 (
      exit /b
    )
  ) else ( 
    dir /b | findstr %jobName%_0000_0001.rst>NUL
    if not !ERRORLEVEL!==0 (
      exit /b
    )
)

  set /a runID+=1
  set jobSuffix=0000!runID!
  set jobSuffix=!jobSuffix:~-4!
  dir /b | findstr %jobName%_!jobSuffix!.rad$>NUL
  if not !ERRORLEVEL!==0 (
    echo Starter complete, no engines found
    exit /b
  )
)

if "%starter%"=="no" if not %runID%==0 (
  :loop
  echo %jobName%_!jobSuffix!>.\running_en_%jobName%
  set jobFileFullPath=%runningDirectory%%jobName%_!jobSuffix!.rad
  if %np%==1 (
      %OPENRADIOSS_PATH%!engineexec! -i !jobFileFullPath! -nt %nt%
  ) else (
  call %MPI_PATH%
  mpiexec -n %np% %OPENRADIOSS_PATH%!enginempiexec! -i !jobFileFullPath! -nt %nt%
  )
  del running_en_%jobName%
  dir /b | findstr %jobName%_!jobSuffix!_0001.rst>NUL
  if not !ERRORLEVEL!==0 (
    exit /b
  )
  set /a runID+=1
  set jobSuffix=0000!runID!
  set jobSuffix=!jobSuffix:~-4!
  dir /b | findstr %jobName%_!jobSuffix!.rad>NUL
  if !ERRORLEVEL!==0 (
    GOTO loop
  )
)

if "%vtk%"=="yes" (
  dir /b | findstr "%jobName%A[0-9][0-9][0-9]$" >NUL
  if not !ERRORLEVEL!==0 (
      echo. 
      echo. 
      echo ---------------------------------------------------------------------
      echo NB: Anim-vtk option selected, but not run since no Anim files present
      echo ---------------------------------------------------------------------
  ) else (
    echo.
    echo.
    echo ------------------------------------------------------
    echo Anim-vtk option selected, Converting Anim Files to vtk
    echo ------------------------------------------------------
    echo.
    for /f "usebackq" %%A in (`dir /b ^| findstr %jobName%A[0-9][0-9][0-9]$`) do (
      echo Anim File Being Converted is %%A
      "%OPENRADIOSS_PATH%/exec/anim_to_vtk_win64.exe" "%%A" > "%%A.vtk"
    )
    echo.
    echo ------------------------------------
    echo Anim file conversion to vtk complete
    echo ------------------------------------
  )
)

if "%csv%"=="yes" (
  dir /b | findstr "%jobName%T[0-9][0-9]$" >NUL
  if not !ERRORLEVEL!==0 (
      echo. 
      echo. 
      echo ----------------------------------------------------------------
      echo NB: TH-csv option selected, but not run since no T files present
      echo ----------------------------------------------------------------
  ) else (
    echo.
    echo.
    echo --------------------------------------------------
    echo TH-csv option selected, Converting TH Files to csv
    echo --------------------------------------------------
    echo.
    for /f "usebackq" %%A in (`dir /b ^| findstr %jobName%T[0-9][0-9]$`) do (
      echo TH File Being Converted is %%A
      "%OPENRADIOSS_PATH%/exec/th_to_csv_win64.exe" "%%A"
    )
    echo.
    echo ----------------------------------
    echo TH file conversion to csv complete
    echo ----------------------------------
  )
)

popd
